Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue.cpp	(revision 88)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue.cpp	(revision 97)
@@ -138,11 +138,17 @@
 // 	sensitive << (*(in_CLOCK)).neg(); // don't need internal register
         for (uint32_t i=0; i<_param->_nb_context; ++i)
-          sensitive << (*( in_EVENT_ACK                            [i]))
-                    << (*( in_EVENT_IFETCH_UNIT_ACK                [i]))
-                    << (*( in_EVENT_CONTEXT_STATE_VAL              [i]))
-                    << (*( in_EVENT_CONTEXT_STATE_ADDRESS          [i]))
-                    << (*( in_EVENT_CONTEXT_STATE_ADDRESS_NEXT     [i]))
-                    << (*( in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]))
-                    << (*( in_EVENT_CONTEXT_STATE_IS_DS_TAKE       [i]));
+          {
+            sensitive << (*( in_EVENT_ACK                            [i]))
+                      << (*( in_EVENT_IFETCH_UNIT_ACK                [i]))
+                      << (*( in_EVENT_PREDICTION_UNIT_ACK            [i]))
+                      << (*( in_EVENT_CONTEXT_STATE_VAL              [i]))
+                      << (*( in_EVENT_CONTEXT_STATE_ADDRESS          [i]))
+                      << (*( in_EVENT_CONTEXT_STATE_ADDRESS_NEXT     [i]))
+                      << (*( in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]))
+                      << (*( in_EVENT_CONTEXT_STATE_IS_DS_TAKE       [i]))
+                      << (*( in_EVENT_CONTEXT_STATE_TYPE             [i]));
+            if (_param->_have_port_depth)
+            sensitive << (*( in_EVENT_CONTEXT_STATE_DEPTH            [i]));
+          }
 
 # ifdef SYSTEMCASS_SPECIFIC
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_allocation.cpp	(revision 88)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_allocation.cpp	(revision 97)
@@ -105,4 +105,9 @@
       ALLOC1_SIGNAL_OUT (out_EVENT_IFETCH_UNIT_ADDRESS_NEXT_VAL                ,"IFETCH_UNIT_ADDRESS_NEXT_VAL"  ,Tcontrol_t           ,1);
       ALLOC1_SIGNAL_OUT (out_EVENT_IFETCH_UNIT_IS_DS_TAKE                      ,"IFETCH_UNIT_IS_DS_TAKE"        ,Tcontrol_t           ,1);
+
+      ALLOC1_SIGNAL_OUT (out_EVENT_PREDICTION_UNIT_VAL                         ,"PREDICTION_UNIT_VAL"           ,Tcontrol_t           ,1);
+      ALLOC1_SIGNAL_IN  ( in_EVENT_PREDICTION_UNIT_ACK                         ,"PREDICTION_UNIT_ACK"           ,Tcontrol_t           ,1);
+      ALLOC1_SIGNAL_OUT (out_EVENT_PREDICTION_UNIT_TYPE                        ,"PREDICTION_UNIT_TYPE"          ,Tevent_type_t        ,_param->_size_event_type);
+      ALLOC1_SIGNAL_OUT (out_EVENT_PREDICTION_UNIT_DEPTH                       ,"PREDICTION_UNIT_DEPTH"         ,Tdepth_t             ,_param->_size_depth);
                                                                                                             
       ALLOC1_SIGNAL_IN  ( in_EVENT_CONTEXT_STATE_VAL                           ,"CONTEXT_STATE_VAL"             ,Tcontrol_t           ,1);
@@ -112,4 +117,7 @@
       ALLOC1_SIGNAL_IN  ( in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL              ,"CONTEXT_STATE_ADDRESS_NEXT_VAL",Tcontrol_t           ,1);
       ALLOC1_SIGNAL_IN  ( in_EVENT_CONTEXT_STATE_IS_DS_TAKE                    ,"CONTEXT_STATE_IS_DS_TAKE"      ,Tcontrol_t           ,1);
+      ALLOC1_SIGNAL_IN  ( in_EVENT_CONTEXT_STATE_TYPE                          ,"CONTEXT_STATE_TYPE"            ,Tevent_type_t        ,_param->_size_event_type);
+      ALLOC1_SIGNAL_IN  ( in_EVENT_CONTEXT_STATE_DEPTH                         ,"CONTEXT_STATE_DEPTH"           ,Tdepth_t             ,_param->_size_depth);
+
     }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_deallocation.cpp	(revision 88)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_deallocation.cpp	(revision 97)
@@ -55,4 +55,10 @@
         DELETE1_SIGNAL(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT_VAL               ,_param->_nb_context,1);
         DELETE1_SIGNAL(out_EVENT_IFETCH_UNIT_IS_DS_TAKE                     ,_param->_nb_context,1);
+
+        DELETE1_SIGNAL(out_EVENT_PREDICTION_UNIT_VAL                        ,_param->_nb_context,1);
+        DELETE1_SIGNAL( in_EVENT_PREDICTION_UNIT_ACK                        ,_param->_nb_context,1);
+        DELETE1_SIGNAL(out_EVENT_PREDICTION_UNIT_TYPE                       ,_param->_nb_context,_param->_size_event_type);
+        DELETE1_SIGNAL(out_EVENT_PREDICTION_UNIT_DEPTH                      ,_param->_nb_context,_param->_size_depth);
+
         DELETE1_SIGNAL( in_EVENT_CONTEXT_STATE_VAL                          ,_param->_nb_context,1);
         DELETE1_SIGNAL(out_EVENT_CONTEXT_STATE_ACK                          ,_param->_nb_context,1);
@@ -61,4 +67,6 @@
         DELETE1_SIGNAL( in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL             ,_param->_nb_context,1);
         DELETE1_SIGNAL( in_EVENT_CONTEXT_STATE_IS_DS_TAKE                   ,_param->_nb_context,1);
+        DELETE1_SIGNAL( in_EVENT_CONTEXT_STATE_TYPE                         ,_param->_nb_context,_param->_size_event_type);
+        DELETE1_SIGNAL( in_EVENT_CONTEXT_STATE_DEPTH                        ,_param->_nb_context,_param->_size_depth);
         
         DELETE1_SIGNAL(out_DEPTH_MIN                                        ,_param->_nb_context,_param->_size_depth  );
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp	(revision 88)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/src/Front_end_Glue_genMealy_event.cpp	(revision 97)
@@ -25,27 +25,66 @@
     for (uint32_t i=0; i<_param->_nb_context; ++i)
       {
-        Taddress_t address = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS [i]);
+        Taddress_t    address = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS [i]);
         PORT_WRITE(out_EVENT_ADDRESS             [i],address);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS [i],address);
 
-        Taddress_t address_next = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT [i]);
+        Taddress_t    address_next = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT [i]);
         PORT_WRITE(out_EVENT_ADDRESS_NEXT             [i],address_next);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT [i],address_next);
 
-        Tcontrol_t address_next_val = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]);
+        Tcontrol_t    address_next_val = PORT_READ(in_EVENT_CONTEXT_STATE_ADDRESS_NEXT_VAL [i]);
         PORT_WRITE(out_EVENT_ADDRESS_NEXT_VAL             [i],address_next_val);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_ADDRESS_NEXT_VAL [i],address_next_val);
 
-        Tcontrol_t is_ds_take = PORT_READ(in_EVENT_CONTEXT_STATE_IS_DS_TAKE [i]);
+        Tcontrol_t    is_ds_take = PORT_READ(in_EVENT_CONTEXT_STATE_IS_DS_TAKE [i]);
         PORT_WRITE(out_EVENT_IS_DS_TAKE             [i],is_ds_take);
         PORT_WRITE(out_EVENT_IFETCH_UNIT_IS_DS_TAKE [i],is_ds_take);
 
-        Tcontrol_t val = PORT_READ(in_EVENT_CONTEXT_STATE_VAL [i]);
-        PORT_WRITE(out_EVENT_VAL             [i],val);
-        PORT_WRITE(out_EVENT_IFETCH_UNIT_VAL [i],val);
+        Tevent_type_t event_type = PORT_READ(in_EVENT_CONTEXT_STATE_TYPE [i]);
+        PORT_WRITE(out_EVENT_PREDICTION_UNIT_TYPE [i],event_type);
+        
+        if (_param->_have_port_depth)
+          {
+        Tdepth_t      depth = PORT_READ(in_EVENT_CONTEXT_STATE_DEPTH [i]);
+        PORT_WRITE(out_EVENT_PREDICTION_UNIT_DEPTH [i],depth);
+          }
+        
 
-        Tcontrol_t ack = (PORT_READ(in_EVENT_ACK             [i]) and
-                          PORT_READ(in_EVENT_IFETCH_UNIT_ACK [i]));
-        PORT_WRITE(out_EVENT_CONTEXT_STATE_ACK [i],ack);
+        Tcontrol_t ack                 = PORT_READ(in_EVENT_ACK                 [i]);
+        Tcontrol_t ifetch_unit_ack     = PORT_READ(in_EVENT_IFETCH_UNIT_ACK     [i]);
+        Tcontrol_t prediction_unit_ack = PORT_READ(in_EVENT_PREDICTION_UNIT_ACK [i]);
+        Tcontrol_t context_state_val   = PORT_READ(in_EVENT_CONTEXT_STATE_VAL   [i]);
+
+        Tcontrol_t val                 = (//ack                 and
+                                            ifetch_unit_ack     and
+                                            prediction_unit_ack and
+                                            context_state_val   
+                                          );
+        Tcontrol_t ifetch_unit_val     = (  ack                 and
+                                          //ifetch_unit_ack     and
+                                            prediction_unit_ack and
+                                            context_state_val   
+                                            );
+        Tcontrol_t prediction_unit_val = (  ack                 and
+                                            ifetch_unit_ack     and
+                                          //prediction_unit_ack and
+                                            context_state_val   
+                                            );
+        Tcontrol_t context_state_ack   = (  ack                 and
+                                            ifetch_unit_ack     and
+                                            prediction_unit_ack // and
+                                          //context_state_val   
+                                            );
+
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * val                 %d, ack                 %d",val                ,ack                );
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * ifetch_unit_val     %d, ifetch_unit_ack     %d",ifetch_unit_val    ,ifetch_unit_ack    );
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * prediction_unit_val %d, prediction_unit_ack %d",prediction_unit_val,prediction_unit_ack);
+        log_printf(TRACE,Front_end_Glue,FUNCTION,"  * context_state_val   %d, context_state_ack   %d",context_state_val  ,context_state_ack  );
+
+
+        PORT_WRITE(out_EVENT_VAL                 [i], val                );
+        PORT_WRITE(out_EVENT_IFETCH_UNIT_VAL     [i], ifetch_unit_val    );
+        PORT_WRITE(out_EVENT_PREDICTION_UNIT_VAL [i], prediction_unit_val);
+        PORT_WRITE(out_EVENT_CONTEXT_STATE_ACK   [i], context_state_ack  );
 
 #ifdef DEBUG
